
;CodeVisionAVR C Compiler V1.25.8 Professional
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 8.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "Gen_mega8.vec"
	.INCLUDE "Gen_mega8.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 Project : Pulse Generator
;       3 Version :
;       4 Date    : 19.09.2010
;       5 Author  : Serega (Deneb-80)
;       6 Company :
;       7 Comments:
;       8 
;       9 
;      10 Chip type           : ATmega8
;      11 Program type        : Application
;      12 Clock frequency     : 8,000000 MHz
;      13 Memory model        : Small
;      14 External SRAM size  : 0
;      15 Data Stack size     : 256
;      16 *****************************************************/
;      17 
;      18 #include <mega8.h>
;      19 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;      20 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      21 	.EQU __se_bit=0x80
	.EQU __se_bit=0x80
;      22 	.EQU __sm_mask=0x70
	.EQU __sm_mask=0x70
;      23 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      24 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      25 	.EQU __sm_standby=0x60
	.EQU __sm_standby=0x60
;      26 	.EQU __sm_ext_standby=0x70
	.EQU __sm_ext_standby=0x70
;      27 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      28 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      29 	#endif
	#endif
;      30 #include <delay.h>
;      31 #include <stdio.h>
;      32 
;      33 // Alphanumeric LCD Module functions
;      34 #asm
;      35    .equ __lcd_port=0x12 ;PORTD
   .equ __lcd_port=0x12 ;PORTD
;      36 #endasm
;      37 #include <lcd.h>
;      38 
;      39 // Declare your global variables here
;      40 
;      41 unsigned char lcd_buffer[16];               //     
_lcd_buffer:
	.BYTE 0x10
;      42 unsigned char i=0;                          // 0...255
;      43 unsigned char j=0;
;      44 unsigned char ENC_COUNT=0;                  //    
;      45 
;      46 unsigned int EncData=0;                       // 0...65535
;      47 unsigned int F0=0;
;      48 float temp;
_temp:
	.BYTE 0x4
;      49 float div1;
_div1:
	.BYTE 0x4
;      50 
;      51 #define Fclk      8000000.000
;      52 
;      53 #define div          64.000                 //   T1.    64,
;      54 #define MIN_VALUE     0                     //     30, ..  
;      55 #define MAX_VALUE 30000                     //      OCR1A
;      56 
;      57 /*******************   **********************/
;      58 void InitEncoder(void)
;      59 {

	.CSEG
_InitEncoder:
;      60   DDRC.5  = 0;      //  PC4, PC5
	CBI  0x14,5
;      61   DDRC.4  = 0;
	CBI  0x14,4
;      62   DDRC.3  = 0;      // 
	CBI  0x14,3
;      63   PORTC.5 = 1;      // .
	SBI  0x15,5
;      64   PORTC.4 = 1;      // 
	SBI  0x15,4
;      65   PORTC.3 = 1;      // 
	SBI  0x15,3
;      66 }
	RET
;      67 
;      68 /***************    *************************/
;      69 
;      70  void Encquest(void)
;      71      {
_Encquest:
;      72 
;      73         if (PINC.3 == 0)                 //   
	SBIC 0x13,3
	RJMP _0xF
;      74           {
;      75             delay_ms(500);               //     
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RCALL SUBOPT_0x0
	RCALL _delay_ms
;      76             if (PINC.3 == 0)
	SBIC 0x13,3
	RJMP _0x10
;      77               {
;      78                 lcd_clear();
	RCALL _lcd_clear
;      79                 lcd_gotoxy(0,0);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x1
	RCALL _lcd_gotoxy
;      80                 #pragma rl+
;      81                 lcd_putsf(" ");     //    
	__POINTW1FN _0,0
	RCALL SUBOPT_0x2
;      82                 lcd_puts(lcd_buffer);
	RCALL SUBOPT_0x3
;      83                 lcd_gotoxy(0,1);
	RCALL SUBOPT_0x4
;      84                 lcd_putsf("  ");
	__POINTW1FN _0,9
	RCALL SUBOPT_0x2
;      85                 #pragma rl-
;      86                 delay_ms(800);
	LDI  R30,LOW(800)
	LDI  R31,HIGH(800)
	RCALL SUBOPT_0x5
;      87                 lcd_clear();
	RCALL _lcd_clear
;      88                 ENC_COUNT++;
	INC  R7
;      89               }
;      90             if (ENC_COUNT>3) {ENC_COUNT = 0;}
_0x10:
	LDI  R30,LOW(3)
	CP   R30,R7
	BRSH _0x11
	CLR  R7
;      91           }
_0x11:
;      92 
;      93            switch (ENC_COUNT)
_0xF:
	MOV  R30,R7
;      94             {
;      95               case 0:{if ((PINC.4==0)&(PINC.5==1)&(EncData<MAX_VALUE))
	CPI  R30,0
	BRNE _0x15
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xA
	LDI  R30,LOW(30000)
	LDI  R31,HIGH(30000)
	RCALL __LTW12U
	AND  R30,R0
	BREQ _0x16
;      96                         {
;      97                           delay_ms(50);
	RCALL SUBOPT_0xB
;      98                           EncData += 1;
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
;      99                         };
_0x16:
;     100                       if ((PINC.4==1)&(PINC.5==0)&(EncData>MIN_VALUE))
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xC
	AND  R30,R0
	BREQ _0x17
;     101                         {
;     102                           delay_ms(50);
	RCALL SUBOPT_0xB
;     103                           EncData -= 1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL SUBOPT_0xD
;     104                         };
_0x17:
;     105                       break;
	RJMP _0x14
;     106                      }
;     107               case 1:{
_0x15:
	CPI  R30,LOW(0x1)
	BRNE _0x18
;     108                       if ((PINC.4==0)&(PINC.5==1)&(EncData<=(MAX_VALUE-10)))
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xA
	LDI  R30,LOW(29990)
	LDI  R31,HIGH(29990)
	RCALL __LEW12U
	AND  R30,R0
	BREQ _0x19
;     109                         {
;     110                           delay_ms(50);
	RCALL SUBOPT_0xB
;     111                           EncData += 10;
	MOVW R30,R8
	ADIW R30,10
	MOVW R8,R30
;     112                       };
_0x19:
;     113                       if ((PINC.4==1)&(PINC.5==0)&(EncData>=(MIN_VALUE+10)))
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xE
	RCALL __GEW12U
	AND  R30,R0
	BREQ _0x1A
;     114                         {
;     115                           delay_ms(50);
	RCALL SUBOPT_0xB
;     116                           EncData -= 10;
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0xD
;     117                         };
_0x1A:
;     118                       break;
	RJMP _0x14
;     119                      }
;     120               case 2:{
_0x18:
	CPI  R30,LOW(0x2)
	BRNE _0x1B
;     121                       if ((PINC.4==0)&(PINC.5==1)&(EncData<=(MAX_VALUE-100)))
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xA
	LDI  R30,LOW(29900)
	LDI  R31,HIGH(29900)
	RCALL __LEW12U
	AND  R30,R0
	BREQ _0x1C
;     122                         {
;     123                           delay_ms(50);
	RCALL SUBOPT_0xB
;     124                           EncData += 100;
	MOVW R30,R8
	SUBI R30,LOW(-100)
	SBCI R31,HIGH(-100)
	MOVW R8,R30
;     125                         };
_0x1C:
;     126                       if ((PINC.4==1)&(PINC.5==0)&(EncData>=(MIN_VALUE+100)))
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0xF
	RCALL __GEW12U
	AND  R30,R0
	BREQ _0x1D
;     127                         {
;     128                           delay_ms(50);
	RCALL SUBOPT_0xB
;     129                           EncData -= 100;
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0xD
;     130                         };
_0x1D:
;     131                       break;
	RJMP _0x14
;     132                      }
;     133               case 3:{
_0x1B:
	CPI  R30,LOW(0x3)
	BRNE _0x14
;     134                       if ((PINC.4==0)&(PINC.5==1)&(EncData<=(MAX_VALUE-1000)))
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0xA
	LDI  R30,LOW(29000)
	LDI  R31,HIGH(29000)
	RCALL __LEW12U
	AND  R30,R0
	BREQ _0x1F
;     135                         {
;     136                           delay_ms(50);
	RCALL SUBOPT_0xB
;     137                           EncData += 1000;
	MOVW R30,R8
	SUBI R30,LOW(-1000)
	SBCI R31,HIGH(-1000)
	MOVW R8,R30
;     138                         };
_0x1F:
;     139                       if ((PINC.4==1)&(PINC.5==0)&(EncData>=(MIN_VALUE+1000)))
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x9
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x10
	RCALL __GEW12U
	AND  R30,R0
	BREQ _0x20
;     140                         {
;     141                           delay_ms(50);
	RCALL SUBOPT_0xB
;     142                           EncData -= 1000;
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0xD
;     143                         };
_0x20:
;     144                       break;
;     145                      }
;     146 
;     147             }        // switch
_0x14:
;     148 
;     149      }      //  
	RET
;     150 
;     151 /*****************    ***********************/
;     152  void LCD_LOAD (void)
;     153  {
_LCD_LOAD:
;     154    while (i<17)
_0x21:
	LDI  R30,LOW(17)
	CP   R5,R30
	BRSH _0x23
;     155        {
;     156          delay_ms (100);
	RCALL SUBOPT_0xF
	RCALL SUBOPT_0x5
;     157          i++;
	INC  R5
;     158          if (i>8)
	LDI  R30,LOW(8)
	CP   R30,R5
	BRSH _0x24
;     159            {
;     160              delay_ms (10);
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x5
;     161              j++;
	INC  R4
;     162              lcd_gotoxy(j-1,1);
	MOV  R30,R4
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(1)
	RJMP _0xFB
;     163             }
;     164          else {lcd_gotoxy(i-1,0);}
_0x24:
	MOV  R30,R5
	SUBI R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(0)
_0xFB:
	ST   -Y,R30
	RCALL _lcd_gotoxy
;     165          lcd_putchar(0xFF);
	LDI  R30,LOW(255)
	ST   -Y,R30
	RCALL _lcd_putchar
;     166         }
	RJMP _0x21
_0x23:
;     167   }
	RET
;     168 
;     169 /****************************************************************/
;     170 
;     171 // Timer 0 overflow interrupt service routine
;     172 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     173 {
_timer0_ovf_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     174 // Place your code here
;     175  Encquest();
	RCALL _Encquest
;     176 
;     177 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     178 
;     179 void main(void)
;     180 {
_main:
;     181 // Declare your local variables here
;     182 
;     183 // Port B initialization
;     184 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
;     185 DDRB=0x00;
	OUT  0x17,R30
;     186 // Port C initialization
;     187 PORTC=0xFF;
	LDI  R30,LOW(255)
	OUT  0x15,R30
;     188 DDRC=0x00;
	LDI  R30,LOW(0)
	OUT  0x14,R30
;     189 // Port D initialization
;     190 PORTD=0x00;
	OUT  0x12,R30
;     191 DDRD=0x00;
	OUT  0x11,R30
;     192 
;     193 // Timer/Counter 0 initialization
;     194 // Clock source: System Clock
;     195 // Clock value: 125,000 kHz
;     196 TCCR0=0x03;
	LDI  R30,LOW(3)
	OUT  0x33,R30
;     197 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x32,R30
;     198 
;     199 // Timer/Counter 1 initialization
;     200 // Clock source: System Clock
;     201 // Clock value: 125,000 kHz
;     202 // Mode: CTC top=OCR1A
;     203 // OC1A output: Toggle
;     204 // OC1B output: Discon.
;     205 // Noise Canceler: Off
;     206 // Input Capture on Falling Edge
;     207 // Timer 1 Overflow Interrupt: Off
;     208 // Input Capture Interrupt: Off
;     209 // Compare A Match Interrupt: Off
;     210 // Compare B Match Interrupt: Off
;     211 TCCR1A=0x40;
	LDI  R30,LOW(64)
	OUT  0x2F,R30
;     212 TCCR1B=0x0B;
	LDI  R30,LOW(11)
	OUT  0x2E,R30
;     213 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     214 TCNT1L=0x00;
	OUT  0x2C,R30
;     215 ICR1H=0x00;
	OUT  0x27,R30
;     216 ICR1L=0x00;
	OUT  0x26,R30
;     217 OCR1AH=0x00;
	OUT  0x2B,R30
;     218 OCR1AL=0x00;
	OUT  0x2A,R30
;     219 OCR1BH=0x00;
	OUT  0x29,R30
;     220 OCR1BL=0x00;
	OUT  0x28,R30
;     221 
;     222 // Timer/Counter 2 initialization
;     223 // Clock source: System Clock
;     224 // Clock value: Timer 2 Stopped
;     225 // Mode: Normal top=FFh
;     226 // OC2 output: Disconnected
;     227 ASSR=0x00;
	OUT  0x22,R30
;     228 TCCR2=0x00;
	OUT  0x25,R30
;     229 TCNT2=0x00;
	OUT  0x24,R30
;     230 OCR2=0x00;
	OUT  0x23,R30
;     231 
;     232 // External Interrupt(s) initialization
;     233 // INT0: Off
;     234 // INT1: Off
;     235 MCUCR=0x00;
	OUT  0x35,R30
;     236 
;     237 // Timer(s)/Counter(s) Interrupt(s) initialization
;     238 TIMSK=0x01;
	LDI  R30,LOW(1)
	OUT  0x39,R30
;     239 
;     240 // Analog Comparator initialization
;     241 // Analog Comparator: Off
;     242 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     243 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     244 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     245 
;     246 /*******************   ***********************/
;     247 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
;     248 
;     249 /*****************   ********************/
;     250 InitEncoder();
	RCALL _InitEncoder
;     251 
;     252 // Global enable interrupts
;     253 #asm("sei")
	sei
;     254 
;     255 //   16x1 ,  8,   ,..
;     256 //       
;     257 LCD_LOAD();
	RCALL _LCD_LOAD
;     258 lcd_clear();                                                //    
	RCALL _lcd_clear
;     259 #pragma rl+
;     260 lcd_putsf("");                                      //     
	__POINTW1FN _0,18
	RCALL SUBOPT_0x2
;     261 lcd_puts(lcd_buffer);                                       //    LCD
	RCALL SUBOPT_0x3
;     262 lcd_gotoxy(0,1);                                            //    
	RCALL SUBOPT_0x4
;     263 lcd_putsf(" .");
	__POINTW1FN _0,27
	RCALL SUBOPT_0x2
;     264 #pragma rl-
;     265 delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	RCALL SUBOPT_0x5
;     266 lcd_clear();
	RCALL _lcd_clear
;     267 
;     268 while (1)
_0x26:
;     269   {
;     270 
;     271       // Place your code here
;     272     if (EncData>0)
	CLR  R0
	CP   R0,R8
	CPC  R0,R9
	BRSH _0x29
;     273       {
;     274         DDRB=0x02;                          //  PB1 
	LDI  R30,LOW(2)
	OUT  0x17,R30
;     275         F0 = EncData;
	MOVW R10,R8
;     276         div1 = (float)(2*div*F0);
	MOVW R30,R10
	CLR  R22
	CLR  R23
	RCALL __CDF1
	__GETD2N 0x43000000
	RCALL __MULF12
	STS  _div1,R30
	STS  _div1+1,R31
	STS  _div1+2,R22
	STS  _div1+3,R23
;     277         temp = (float)((Fclk/div1)-1);        //   2 -      
	__GETD2N 0x4AF42400
	RCALL __DIVF21
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x3F800000
	RCALL __SWAPD12
	RCALL __SUBF12
	STS  _temp,R30
	STS  _temp+1,R31
	STS  _temp+2,R22
	STS  _temp+3,R23
;     278         OCR1A = temp;
	RCALL __CFD1U
	OUT  0x2A+1,R31
	OUT  0x2A,R30
;     279       }
;     280     if (F0!=EncData)
_0x29:
	__CPWRR 8,9,10,11
	BREQ _0x2A
;     281      {
;     282       F0 = EncData;
	MOVW R10,R8
;     283      }
;     284     if ((F0>0)&(F0<1000))
_0x2A:
	RCALL SUBOPT_0x11
	MOV  R0,R30
	RCALL SUBOPT_0x12
	RCALL __LTW12U
	AND  R30,R0
	BREQ _0x2B
;     285       {
;     286         lcd_gotoxy(0,0);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x13
;     287         sprintf(lcd_buffer, "%8u", F0);
	__POINTW1FN _0,35
	RCALL SUBOPT_0x0
	MOVW R30,R10
	RCALL SUBOPT_0x14
	LDI  R24,4
	RCALL _sprintf
	ADIW R28,8
;     288         lcd_puts(lcd_buffer);                                 //    LCD
	RCALL SUBOPT_0x3
;     289         lcd_gotoxy(0,1);                                      //    
	RCALL SUBOPT_0x4
;     290         #pragma rl+
;     291         lcd_putsf("      ");
	__POINTW1FN _0,39
	RCALL SUBOPT_0x2
;     292         lcd_puts(lcd_buffer);
	RJMP _0xFC
;     293         #pragma rl-
;     294       }
;     295 
;     296     else
_0x2B:
;     297     {
;     298       if (F0>0)
	CLR  R0
	CP   R0,R10
	CPC  R0,R11
	BRSH _0x2D
;     299         {
;     300           lcd_gotoxy(0,1);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x4
;     301           #pragma rl+
;     302           lcd_putsf("     ");                                    //    
	__POINTW1FN _0,48
	RCALL SUBOPT_0x2
;     303           lcd_puts(lcd_buffer);
	RCALL SUBOPT_0x15
;     304           #pragma rl-
;     305         }
;     306       if ((F0>0)&(F0%1000)<10)
_0x2D:
	RCALL SUBOPT_0x11
	MOV  R22,R30
	RCALL SUBOPT_0x12
	RCALL __MODW21U
	MOVW R26,R30
	RCALL SUBOPT_0xE
	RCALL __LTW12U
	AND  R30,R22
	BREQ _0x2E
;     307         {
;     308           lcd_gotoxy(0,0);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x13
;     309           sprintf(lcd_buffer,"%4u.00%u", F0/1000, F0%1000);
	__POINTW1FN _0,57
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x12
	RCALL __DIVW21U
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x12
	RCALL __MODW21U
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x16
;     310           lcd_puts(lcd_buffer);
;     311         }
;     312 
;     313       if ((F0>0)&((F0%1000)>=10)&((F0%1000)<100))
_0x2E:
	RCALL SUBOPT_0x11
	MOV  R22,R30
	RCALL SUBOPT_0x12
	RCALL __MODW21U
	MOVW R26,R30
	RCALL SUBOPT_0xE
	RCALL __GEW12U
	AND  R22,R30
	RCALL SUBOPT_0x12
	RCALL __MODW21U
	MOVW R26,R30
	RCALL SUBOPT_0xF
	RCALL __LTW12U
	AND  R30,R22
	BREQ _0x2F
;     314         {
;     315           lcd_gotoxy(0,0);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x13
;     316           sprintf(lcd_buffer,"%4u.0%u", F0/1000, F0%1000);
	__POINTW1FN _0,66
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x12
	RCALL __DIVW21U
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x12
	RCALL __MODW21U
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x16
;     317           lcd_puts(lcd_buffer);
;     318         }
;     319 
;     320       if ((F0>0)&(F0%1000)>=100)
_0x2F:
	RCALL SUBOPT_0x11
	MOV  R22,R30
	RCALL SUBOPT_0x12
	RCALL __MODW21U
	MOVW R26,R30
	RCALL SUBOPT_0xF
	RCALL __GEW12U
	AND  R30,R22
	BREQ _0x30
;     321         {
;     322           lcd_gotoxy(0,0);
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x1
	RCALL SUBOPT_0x13
;     323           sprintf(lcd_buffer,"%4u.%u", F0/1000, F0%1000);
	__POINTW1FN _0,74
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x12
	RCALL __DIVW21U
	RCALL SUBOPT_0x14
	RCALL SUBOPT_0x12
	RCALL __MODW21U
	RCALL SUBOPT_0x14
	LDI  R24,8
	RCALL _sprintf
	ADIW R28,12
;     324           lcd_puts(lcd_buffer);
_0xFC:
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	RCALL SUBOPT_0x0
	RCALL _lcd_puts
;     325         }
;     326 
;     327     }  // else
_0x30:
;     328 
;     329 
;     330   };
	RJMP _0x26
;     331 }
_0x31:
	RJMP _0x31

	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	RCALL __SAVELOCR2
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0x3F
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x41
	__CPWRN 16,17,2
	BRLO _0x42
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x41:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x42:
	RJMP _0x43
_0x3F:
	LDD  R30,Y+6
	ST   -Y,R30
	RCALL _putchar
_0x43:
	RCALL __LOADLOCR2
	ADIW R28,7
	RET
__print_G2:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
_0x44:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x46
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x4A
	CPI  R18,37
	BRNE _0x4B
	LDI  R17,LOW(1)
	RJMP _0x4C
_0x4B:
	RCALL SUBOPT_0x17
_0x4C:
	RJMP _0x49
_0x4A:
	CPI  R30,LOW(0x1)
	BRNE _0x4D
	CPI  R18,37
	BRNE _0x4E
	RCALL SUBOPT_0x17
	RJMP _0xFD
_0x4E:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x4F
	LDI  R16,LOW(1)
	RJMP _0x49
_0x4F:
	CPI  R18,43
	BRNE _0x50
	LDI  R20,LOW(43)
	RJMP _0x49
_0x50:
	CPI  R18,32
	BRNE _0x51
	LDI  R20,LOW(32)
	RJMP _0x49
_0x51:
	RJMP _0x52
_0x4D:
	CPI  R30,LOW(0x2)
	BRNE _0x53
_0x52:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x54
	ORI  R16,LOW(128)
	RJMP _0x49
_0x54:
	RJMP _0x55
_0x53:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x49
_0x55:
	CPI  R18,48
	BRLO _0x58
	CPI  R18,58
	BRLO _0x59
_0x58:
	RJMP _0x57
_0x59:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x49
_0x57:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x5D
	RCALL SUBOPT_0x18
	LD   R30,X
	RCALL SUBOPT_0x19
	RJMP _0x5E
_0x5D:
	CPI  R30,LOW(0x73)
	BRNE _0x60
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x1A
	RCALL _strlen
	MOV  R17,R30
	RJMP _0x61
_0x60:
	CPI  R30,LOW(0x70)
	BRNE _0x63
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x1A
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x61:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x64
_0x63:
	CPI  R30,LOW(0x64)
	BREQ _0x67
	CPI  R30,LOW(0x69)
	BRNE _0x68
_0x67:
	ORI  R16,LOW(4)
	RJMP _0x69
_0x68:
	CPI  R30,LOW(0x75)
	BRNE _0x6A
_0x69:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	RCALL SUBOPT_0x1B
	LDI  R17,LOW(5)
	RJMP _0x6B
_0x6A:
	CPI  R30,LOW(0x58)
	BRNE _0x6D
	ORI  R16,LOW(8)
	RJMP _0x6E
_0x6D:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x9F
_0x6E:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	RCALL SUBOPT_0x1B
	LDI  R17,LOW(4)
_0x6B:
	SBRS R16,2
	RJMP _0x70
	RCALL SUBOPT_0x18
	RCALL __GETW1P
	RCALL SUBOPT_0x1C
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x71
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	RCALL SUBOPT_0x1C
	LDI  R20,LOW(45)
_0x71:
	CPI  R20,0
	BREQ _0x72
	SUBI R17,-LOW(1)
	RJMP _0x73
_0x72:
	ANDI R16,LOW(251)
_0x73:
	RJMP _0x74
_0x70:
	RCALL SUBOPT_0x18
	RCALL __GETW1P
	RCALL SUBOPT_0x1C
_0x74:
_0x64:
	SBRC R16,0
	RJMP _0x75
_0x76:
	CP   R17,R21
	BRSH _0x78
	SBRS R16,7
	RJMP _0x79
	SBRS R16,2
	RJMP _0x7A
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x7B
_0x7A:
	LDI  R18,LOW(48)
_0x7B:
	RJMP _0x7C
_0x79:
	LDI  R18,LOW(32)
_0x7C:
	RCALL SUBOPT_0x17
	SUBI R21,LOW(1)
	RJMP _0x76
_0x78:
_0x75:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x7D
_0x7E:
	CPI  R19,0
	BREQ _0x80
	SBRS R16,3
	RJMP _0x81
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	RCALL SUBOPT_0x1B
	SBIW R30,1
	LPM  R30,Z
	RJMP _0xFE
_0x81:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0xFE:
	ST   -Y,R30
	RCALL SUBOPT_0x1D
	CPI  R21,0
	BREQ _0x83
	SUBI R21,LOW(1)
_0x83:
	SUBI R19,LOW(1)
	RJMP _0x7E
_0x80:
	RJMP _0x84
_0x7D:
_0x86:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	RCALL SUBOPT_0x1B
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x88:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x8A
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0x1C
	RJMP _0x88
_0x8A:
	CPI  R18,58
	BRLO _0x8B
	SBRS R16,3
	RJMP _0x8C
	SUBI R18,-LOW(7)
	RJMP _0x8D
_0x8C:
	SUBI R18,-LOW(39)
_0x8D:
_0x8B:
	SBRC R16,4
	RJMP _0x8F
	CPI  R18,49
	BRSH _0x91
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x90
_0x91:
	RJMP _0xFF
_0x90:
	CP   R21,R19
	BRLO _0x95
	SBRS R16,0
	RJMP _0x96
_0x95:
	RJMP _0x94
_0x96:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x97
	LDI  R18,LOW(48)
_0xFF:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x98
	ANDI R16,LOW(251)
	ST   -Y,R20
	RCALL SUBOPT_0x1D
	CPI  R21,0
	BREQ _0x99
	SUBI R21,LOW(1)
_0x99:
_0x98:
_0x97:
_0x8F:
	RCALL SUBOPT_0x17
	CPI  R21,0
	BREQ _0x9A
	SUBI R21,LOW(1)
_0x9A:
_0x94:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x87
	RJMP _0x86
_0x87:
_0x84:
	SBRS R16,0
	RJMP _0x9B
_0x9C:
	CPI  R21,0
	BREQ _0x9E
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x19
	RJMP _0x9C
_0x9E:
_0x9B:
_0x9F:
_0x5E:
_0xFD:
	LDI  R17,LOW(0)
_0x49:
	RJMP _0x44
_0x46:
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	RCALL __SAVELOCR2
	MOVW R26,R28
	RCALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,6
	RCALL __ADDW2R15
	RCALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0x0
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	RCALL SUBOPT_0x0
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0x0
	RCALL __print_G2
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	RCALL __LOADLOCR2
	ADIW R28,4
	POP  R15
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G3:
	.BYTE 0x4

	.CSEG
__lcd_delay_G3:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G3
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G3
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G3
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G3
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G3:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G3
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G3
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output    
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G3
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G3
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble_G3:
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G3
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G3
    andi  r30,0xf0
	RET
_lcd_read_byte0_G3:
	RCALL __lcd_delay_G3
	RCALL __lcd_read_nibble_G3
    mov   r26,r30
	RCALL __lcd_read_nibble_G3
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G3)
	SBCI R31,HIGH(-__base_y_G3)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x1E
	LDD  R6,Y+1
	LDD  R13,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x1E
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x1E
	RCALL __lcd_ready
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x1E
	LDI  R30,LOW(0)
	MOV  R13,R30
	MOV  R6,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R6
	CP   R12,R6
	BRSH _0xEC
	__lcd_putchar1:
	INC  R13
	RCALL SUBOPT_0x1
	ST   -Y,R13
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0xEC:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
	ST   -Y,R17
_0xED:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0xEF
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0xED
_0xEF:
	LDD  R17,Y+0
	RJMP _0xFA
_lcd_putsf:
	ST   -Y,R17
_0xF0:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0xF2
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0xF0
_0xF2:
	LDD  R17,Y+0
_0xFA:
	ADIW R28,3
	RET
__long_delay_G3:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G3:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G3
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R12,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G3,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G3,3
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x1F
	RCALL __long_delay_G3
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G3
	RCALL __long_delay_G3
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x1E
	RCALL __long_delay_G3
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x1E
	RCALL __long_delay_G3
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x1E
	RCALL __long_delay_G3
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G3
	CPI  R30,LOW(0x5)
	BREQ _0xF3
	LDI  R30,LOW(0)
	RJMP _0xF9
_0xF3:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x1E
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0xF9:
	ADIW R28,1
	RET
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
    lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.DSEG
_p_S58:
	.BYTE 0x2

	.CSEG

;OPTIMIZER ADDED SUBROUTINE, CALLED 55 TIMES, CODE SIZE REDUCTION:52 WORDS
SUBOPT_0x0:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2:
	RCALL SUBOPT_0x0
	RJMP _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	RCALL SUBOPT_0x0
	RCALL _lcd_puts
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x5:
	RCALL SUBOPT_0x0
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x6:
	LDI  R30,0
	SBIC 0x13,4
	LDI  R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x7:
	LDI  R26,LOW(0)
	RCALL __EQB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x8:
	MOV  R0,R30
	LDI  R30,0
	SBIC 0x13,5
	LDI  R30,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x9:
	LDI  R26,LOW(1)
	RCALL __EQB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xA:
	AND  R0,R30
	MOVW R26,R8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0xB:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL __GTW12U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	__SUBWRR 8,9,30,31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x10:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	MOVW R26,R10
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x12:
	MOVW R26,R10
	RJMP SUBOPT_0x10

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x13:
	RCALL _lcd_gotoxy
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x14:
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x15:
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	RCALL SUBOPT_0x0
	RJMP _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x16:
	LDI  R24,8
	RCALL _sprintf
	ADIW R28,12
	RJMP SUBOPT_0x15

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x17:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x0
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x0
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x18:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	SBIW R26,4
	STD  Y+16,R26
	STD  Y+16+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x19:
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x0
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x0
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1A:
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1B:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1D:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x0
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x0
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1E:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1F:
	RCALL __long_delay_G3
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G3

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__LEW12U:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BRSH __LEW12UT
	CLR  R30
__LEW12UT:
	RET

__GEW12U:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRSH __GEW12UT
	CLR  R30
__GEW12UT:
	RET

__LTW12U:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRLO __LTW12UT
	CLR  R30
__LTW12UT:
	RET

__GTW12U:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BRLO __GTW12UT
	CLR  R30
__GTW12UT:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
