/*****************************************************
Project : Pulse Generator
Version :
Date    : 19.09.2010
Author  : Serega (Deneb-80)
Company :
Comments:


Chip type           : ATmega8
Program type        : Application
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#include <delay.h>
#include <stdio.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x12 ;PORTD
#endasm
#include <lcd.h>

// Declare your global variables here

unsigned char lcd_buffer[16];               //     
unsigned char i=0;                          // 0...255
unsigned char j=0;
unsigned char ENC_COUNT=0;                  //    

unsigned int EncData=0;                       // 0...65535
unsigned int F0=0;
float temp;
float div1;

#define Fclk      8000000.000

#define div          64.000                 //   T1.    64,
#define MIN_VALUE     0                     //     30, ..  
#define MAX_VALUE 30000                     //      OCR1A

/*******************   **********************/
void InitEncoder(void)
{
  DDRC.5  = 0;      //  PC4, PC5
  DDRC.4  = 0;
  DDRC.3  = 0;      // 
  PORTC.5 = 1;      // .
  PORTC.4 = 1;      // 
  PORTC.3 = 1;      // 
}

/***************    *************************/

 void Encquest(void)
     {

        if (PINC.3 == 0)                 //   
          {
            delay_ms(500);               //     
            if (PINC.3 == 0)
              {
                lcd_clear();
                lcd_gotoxy(0,0);
                #pragma rl+
                lcd_putsf(" ");     //    
                lcd_puts(lcd_buffer);
                lcd_gotoxy(0,1);
                lcd_putsf("  ");
                #pragma rl-
                delay_ms(800);
                lcd_clear();
                ENC_COUNT++;
              }
            if (ENC_COUNT>3) {ENC_COUNT = 0;}
          }

           switch (ENC_COUNT)
            {
              case 0:{if ((PINC.4==0)&(PINC.5==1)&(EncData<MAX_VALUE))
                        {
                          delay_ms(50);
                          EncData += 1;
                        };
                      if ((PINC.4==1)&(PINC.5==0)&(EncData>MIN_VALUE))
                        {
                          delay_ms(50);
                          EncData -= 1;
                        };
                      break;
                     }
              case 1:{
                      if ((PINC.4==0)&(PINC.5==1)&(EncData<=(MAX_VALUE-10)))
                        {
                          delay_ms(50);
                          EncData += 10;
                      };
                      if ((PINC.4==1)&(PINC.5==0)&(EncData>=(MIN_VALUE+10)))
                        {
                          delay_ms(50);
                          EncData -= 10;
                        };
                      break;
                     }
              case 2:{
                      if ((PINC.4==0)&(PINC.5==1)&(EncData<=(MAX_VALUE-100)))
                        {
                          delay_ms(50);
                          EncData += 100;
                        };
                      if ((PINC.4==1)&(PINC.5==0)&(EncData>=(MIN_VALUE+100)))
                        {
                          delay_ms(50);
                          EncData -= 100;
                        };
                      break;
                     }
              case 3:{
                      if ((PINC.4==0)&(PINC.5==1)&(EncData<=(MAX_VALUE-1000)))
                        {
                          delay_ms(50);
                          EncData += 1000;
                        };
                      if ((PINC.4==1)&(PINC.5==0)&(EncData>=(MIN_VALUE+1000)))
                        {
                          delay_ms(50);
                          EncData -= 1000;
                        };
                      break;
                     }

            }        // switch

     }      //  

/*****************    ***********************/
 void LCD_LOAD (void)
 {
   while (i<17)
       {
         delay_ms (100);
         i++;
         if (i>8)
           {
             delay_ms (10);
             j++;
             lcd_gotoxy(j-1,1);
            }
         else {lcd_gotoxy(i-1,0);}
         lcd_putchar(0xFF);
        }
  }

/****************************************************************/

// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
// Place your code here
 Encquest();

}

void main(void)
{
// Declare your local variables here

// Port B initialization
PORTB=0x00;
DDRB=0x00;
// Port C initialization
PORTC=0xFF;
DDRC=0x00;
// Port D initialization
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 125,000 kHz
TCCR0=0x03;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 125,000 kHz
// Mode: CTC top=OCR1A
// OC1A output: Toggle
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x40;
TCCR1B=0x0B;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

/*******************   ***********************/
lcd_init(16);

/*****************   ********************/
InitEncoder();

// Global enable interrupts
#asm("sei")

//   16x1 ,  8,   ,..
//       
LCD_LOAD();
lcd_clear();                                                //    
#pragma rl+
lcd_putsf("");                                      //     
lcd_puts(lcd_buffer);                                       //    LCD
lcd_gotoxy(0,1);                                            //    
lcd_putsf(" .");
#pragma rl-
delay_ms(2000);
lcd_clear();

while (1)
  {

      // Place your code here
    if (EncData>0)
      {
        DDRB=0x02;                          //  PB1 
        F0 = EncData;
        div1 = (float)(2*div*F0);
        temp = (float)((Fclk/div1)-1);        //   2 -      
        OCR1A = temp;
      }
    if (F0!=EncData)
     {
      F0 = EncData;
     }
    if ((F0>0)&(F0<1000))
      {
        lcd_gotoxy(0,0);
        sprintf(lcd_buffer, "%8u", F0);
        lcd_puts(lcd_buffer);                                 //    LCD
        lcd_gotoxy(0,1);                                      //    
        #pragma rl+
        lcd_putsf("      ");
        lcd_puts(lcd_buffer);
        #pragma rl-
      }

    else
    {
      if (F0>0)
        {
          lcd_gotoxy(0,1);
          #pragma rl+
          lcd_putsf("     ");                                    //    
          lcd_puts(lcd_buffer);
          #pragma rl-
        }
      if ((F0>0)&(F0%1000)<10)
        {
          lcd_gotoxy(0,0);
          sprintf(lcd_buffer,"%4u.00%u", F0/1000, F0%1000);
          lcd_puts(lcd_buffer);
        }

      if ((F0>0)&((F0%1000)>=10)&((F0%1000)<100))
        {
          lcd_gotoxy(0,0);
          sprintf(lcd_buffer,"%4u.0%u", F0/1000, F0%1000);
          lcd_puts(lcd_buffer);
        }

      if ((F0>0)&(F0%1000)>=100)
        {
          lcd_gotoxy(0,0);
          sprintf(lcd_buffer,"%4u.%u", F0/1000, F0%1000);
          lcd_puts(lcd_buffer);
        }

    }  // else


  };
}
